#include <fstream.h>
#include "stdafx.h"
#include "TrafficLightsDlg.h"
#include "TrafficLights.h"

CAutomat::CAutomat()
{
	y0 = 0;
	on = false;

	LOGGING = true;
	cur_mode = AUTO;
	button_on = false;
	broken_red = false;
	broken_yellow = false;
	broken_green = false;
	broken = false;
	button_pressed = false;

	if(LOGGING)
	{
		logfile.open(logname);
	}
}

CAutomat::~CAutomat()
{
	if(LOGGING)
	{
		logfile.close();
	}
}

void CAutomat::A0(int e)
{
	int yold = y0;

	if(LOGGING)
		log_begin(y0, e);

	switch(y0)
	{
		case 0:
			if(e == 5 && x9())						{ y0 = 7; }
			else if((e == 5 || x7()) && !x4() && !x5() && !x6())	{ y0 = 1; }
			break;
		case 1:
			if(e == 7 && x1() || e == 4 && x2() || e == 3) { y0 = 2; }
			if(x4() || x6())					 { z1(); y0 = 7; }
			if(e == 2)							 { y0 = 7; }
			if(e == 6 || x5())                   { z1(); y0 = 0; }
			break;
		case 2:
			if(e == 8)                           { y0 = 3; }
			if(x4() || x6())					 { z1(); y0 = 7; }
			if(e == 2)							 { y0 = 7; }
			if(e == 6 || x5())                   { z1(); y0 = 0; }
			break;
		case 3:
			if(e == 8)                           { y0 = 4; }
			if(x4() || x6())					 { z1(); y0 = 7; }
			if(e == 2)							 { y0 = 7; }
			if(e == 6 || x5())                   { z1(); y0 = 0; }
			break;
		case 4:
			if(e == 7 && x1() && x3() && !x8())	 { y0 = 5; }
			if(e == 4 && x2())					 { y0 = 6; }
			if(e == 7 && x1() && x3() && x8())	 { y0 = 6; }
			if(e == 7 && x1() && !x3() || e == 3) { y0 = 6; }
			if(x4() || x6())					 { z1(); y0 = 7; }
			if(e == 2)							 { y0 = 7; }
			if(e == 6 || x5())                   { z1(); y0 = 0; }
			break;
		case 5:
			if(e == 1 && x1() || e == 10 && x1() && !x3() || e == 4 && x2() || e == 3) { y0 = 6; }
			if(x4() || x6())					 { z1(); y0 = 7; }
			if(e == 2)							 { y0 = 7; }
			if(e == 6 || x5())                   { z1(); y0 = 0; }
			break;
		case 6:
			if(e == 8)                           { y0 = 1; }
			if(x4() || x6())					 { z1(); y0 = 7; }
			if(e == 2)							 { y0 = 7; }
			if(e == 6 || x5())                   { z1(); y0 = 0; }
			break;
		case 7:
			if((e == 3 || e == 9 || x7()) && !x4() && !x6()) { y0 = 1; }
			if(e == 6 || x5())                   { z1(); y0 = 0; }
			break;
		default:
			if(LOGGING)
				log_err(y0);
	}

	if(y0 != yold)
	{
		if(LOGGING)
			log_trans(y0, yold);

		switch(y0)
		{
			case 0:
				{ z10(); }
				break;
			case 1:
				{ z2(); z4(); }
				break;
			case 2:
				{ z3();	z5(); }
				break;
			case 3:
				{ z3(); z6(); }
				break;
			case 4:
				{ z2(); z7(); z11();}
				break;
			case 5:
				break;
			case 6:
				{ z3(); z8(); }
				break;
			case 7:
				{ z9(); }
				break;
			default:
				if(LOGGING)
					log_err(y0);
		}
	}

	if(LOGGING)
		log_end(y0);
}

/**********************************************************************************************
										 
**********************************************************************************************/

void CAutomat::auto_mode()
{
	A0(3);
	cur_mode = AUTO;
}

void CAutomat::manual_mode()
{
	A0(9);
	cur_mode = MANUAL;
}

void CAutomat::blinking_mode()
{
	cur_mode = BLINKING;
	A0(2);
}

void CAutomat::switch_button()
{
	button_on = !button_on;
	if( button_on == false )
	{
		A0(10);
	}
}

void CAutomat::power_button()
{
	if(on)
	{
		on = false;
		A0(6);
	}
	else
	{
		on = true;
		A0(5);
	}
}

void CAutomat::switch_lights()
{
	A0(4);
}

void CAutomat::buttonpressed()
{
	button_pressed = true;
	A0(1);
}

void CAutomat::long_time_elapsed()
{
	A0(7);
}

void CAutomat::short_time_elapsed()
{
	A0(8);
}

/**********************************************************************************************
									 
**********************************************************************************************/

void CAutomat::z1()
{
	broken = true;
	if(LOGGING)
		log_output(1, " ");
}

void CAutomat::z2()
{
	SetTimer(LTIMER, 5000, NULL);
	if(LOGGING)
		log_output(2, " '' ");
}

void CAutomat::z3()
{
	SetTimer(STIMER, 3000, NULL);
	if(LOGGING)
		log_output(3, " '' ");
}

void CAutomat::z4()
{
	light(GREEN);
	if(LOGGING)
		log_output(4, " ");
}

void CAutomat::z5()
{
	light(BLINKGREEN);
	if(LOGGING)
		log_output(5, "  ");
}

void CAutomat::z6()
{
	light(YELLOW);
	if(LOGGING)
		log_output(6, " ");
}

void CAutomat::z7()
{
	light(RED);
	if(LOGGING)
		log_output(7, " ");
}

void CAutomat::z8()
{
	light(REDYELLOW);
	if(LOGGING)
		log_output(8, "   ");
}

void CAutomat::z9()
{
	light(BLINKYELLOW);
	if(LOGGING)
		log_output(9, "  ");
}

void CAutomat::z10()
{
	light(OFF);
	if(LOGGING)
		log_output(10, " ");
}

void CAutomat::z11()
{
	button_pressed = false;
	if(LOGGING)
		log_output(11, "  ");
}

/**********************************************************************************************
									 
**********************************************************************************************/

bool CAutomat::x1()
{
	bool res = cur_mode == AUTO;
	if(LOGGING)
		log_input(1, " ", res);
	return res;
}

bool CAutomat::x2()
{
	bool res = cur_mode == MANUAL;
	if(LOGGING)
		log_input(2, " ", res);
	return res;
}

bool CAutomat::x3()
{
	bool res = button_on;
	if(LOGGING)
		log_input(3, " ", res);
	return res;
}

bool CAutomat::x4()
{
	bool res = broken_red;
	if(LOGGING)
		log_input(4, " ", res);
	return res;
}

bool CAutomat::x5()
{
	bool res = broken_yellow;
	if(LOGGING)
		log_input(5, " ", res);
	return res;
}

bool CAutomat::x6()
{
	bool res = broken_green;
	if(LOGGING)
		log_input(6, " ", res);
	return res;
}

bool CAutomat::x7()
{
	bool res = broken;
	if(LOGGING)
		log_input(7, " ", res);
	return res;
}

bool CAutomat::x8()
{
	bool res = button_pressed;
	if(LOGGING)
		log_input(8, "  ''", res);
	return res;
}

bool CAutomat::x9()
{
	bool res = cur_mode == BLINKING;
	if(LOGGING)
		log_input(9, " ", res);
	return res;
}

/**********************************************************************************************
									 
**********************************************************************************************/

void CAutomat::brokenred()
{
	broken_red = true;
}

void CAutomat::brokenyellow()
{
	broken_yellow = true;
}

void CAutomat::brokengreen()
{
	broken_green = true;
}

void CAutomat::fixedred()
{
	broken_red = false;
}

void CAutomat::fixedyellow()
{
	broken_yellow = false;
}

void CAutomat::fixedgreen()
{
	broken_green = false;
}

void CAutomat::light(states what)
{
	(((CTrafficLightsDlg *)(((CTrafficLightsApp *)AfxGetApp())->m_pMainWnd))->m_Canvas).SetMode(what);
}

void CAutomat::log_begin(int state, int event)
{
	logfile << "{  A0      " << state;
	logfile << "   e" << event << endl;
}

void CAutomat::log_end(int state)
{
	logfile << " 0      " << state;
	logfile << "}" << endl;
}

void CAutomat::log_input(int id, char* comment, bool result)
{
	char* res;
	res = result ? "" : "";

	logfile << " I ";
	logfile << "x" << id << ": " << comment << "? - " << res << endl;
}

void CAutomat::log_output(int id, char* comment)
{
	logfile << " O ";
	logfile << "z" << id << ": " << comment << endl;
}

void CAutomat::log_err(int state)
{
	logfile << " E ";
	logfile << " : " << state << endl;
}

void CAutomat::log_trans(int to, int from)
{
	logfile << " 0    " << from;
	logfile << "   " << to << "}{" << endl;
}


BEGIN_MESSAGE_MAP(CAutomat, CWnd)
	//{{AFX_MSG_MAP(CAutomat)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void CAutomat::OnTimer(UINT nIDEvent) 
{
	KillTimer(nIDEvent);
	if(nIDEvent == LTIMER)
		long_time_elapsed();
	if(nIDEvent == STIMER)
		short_time_elapsed();
}